#! /bin/bash

export PATH="$PATH:../tools"

rm -f d*.nmask{~,%} "regen-d.sh~"

npic-mask d4_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:1 \
  -vec 1:1:2

npic-mask d8_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:1 \
  -vec 1:1:1

npic-mask d-2-3_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:2 \
  -vec 1:1:3

npic-mask d-3-4_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:3 \
  -vec 1:1:4

npic-mask d-5-7-11_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:5 \
  -vec 1:1:7 \
  -vec 1:2:11

npic-mask d-5-7-d16_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:5 \
  -vec 1:1:7 \
  -vec 1:3:16

npic-mask d-14-20-31-44_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:14 \
  -vec 1:1:20 \
  -vec 1:2:31 \
  -vec 1:3:44

npic-mask d-62-88-139-196-224_2l.nmask -create -2l -dist -wd -ghalf \
  -vec 0:1:62 \
  -vec 1:1:88 \
  -vec 1:2:139 \
  -vec 1:3:196 \
  -vec 2:3:224


npic-mask d-M1_2d.nmask -create -2d -dist -wd -ghalf \
  -vec 0:1:1.0 \
  -vec 1:1:1.414213

npic-mask d-M2_2d.nmask -create -2d -dist -wd -ghalf \
  -vec 0:1:1.0 \
  -vec 1:1:1.414213 \
  -vec 1:2:2.236068


npic-mask d6_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:1 \
  -vec 0:1:1:2 \
  -vec 1:1:1:3

npic-mask d18_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:1 \
  -vec 0:1:1:1 \
  -vec 1:1:1:2

npic-mask d26_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:1 \
  -vec 0:1:1:1 \
  -vec 1:1:1:1

npic-mask d-3-4-5_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:3 \
  -vec 0:1:1:4 \
  -vec 1:1:1:5

npic-mask d-3-4-5-7_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:3 \
  -vec 0:1:1:4 \
  -vec 1:1:1:5 \
  -vec 1:1:2:7

npic-mask d-7-10-13-18_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:7 \
  -vec 0:1:1:10 \
  -vec 1:1:1:13 \
  -vec 1:1:2:18

npic-mask d-4-6-7-9-10_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:4 \
  -vec 0:1:1:6 \
  -vec 1:1:1:7 \
  -vec 0:1:2:9 \
  -vec 1:1:2:10

npic-mask d-7-10-12-16-17_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:7 \
  -vec 0:1:1:10 \
  -vec 1:1:1:12 \
  -vec 0:1:2:16 \
  -vec 1:1:2:17

npic-mask d-11-16-19-45_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:11 \
  -vec 0:1:1:16 \
  -vec 1:1:1:19 \
  -vec 1:2:3:45

npic-mask d-19-27-33_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:19 \
  -vec 0:1:1:27 \
  -vec 1:1:1:33

npic-mask d-19-27-33-43-47_3l.nmask -create -3l -dist -wd -ghalf \
  -vec 0:0:1:19 \
  -vec 0:1:1:27 \
  -vec 1:1:1:33 \
  -vec 0:1:2:43 \
  -vec 1:1:2:47


npic-mask d8_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:1 \
  -vec 0:0:1:1:2 \
  -vec 0:1:1:1:3 \
  -vec 1:1:1:1:4

npic-mask d32_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:1 \
  -vec 0:0:1:1:1 \
  -vec 0:1:1:1:2 \
  -vec 1:1:1:1:3

npic-mask d64_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:1 \
  -vec 0:0:1:1:1 \
  -vec 0:1:1:1:1 \
  -vec 1:1:1:1:2

npic-mask d80_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:1 \
  -vec 0:0:1:1:1 \
  -vec 0:1:1:1:1 \
  -vec 1:1:1:1:1

npic-mask d-3-4-5-6_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:3 \
  -vec 0:0:1:1:4 \
  -vec 0:1:1:1:5 \
  -vec 1:1:1:1:6

npic-mask d-7-10-12-13_4l.nmask -create -4l -dist -wd -ghalf \
  -vec 0:0:0:1:7 \
  -vec 0:0:1:1:10 \
  -vec 0:1:1:1:12 \
  -vec 1:1:1:1:13


npic-mask d10_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:1 \
  -vec 0:0:0:1:1:2 \
  -vec 0:0:1:1:1:3 \
  -vec 0:1:1:1:1:4 \
  -vec 1:1:1:1:1:5

npic-mask d50_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:1 \
  -vec 0:0:0:1:1:1 \
  -vec 0:0:1:1:1:2 \
  -vec 0:1:1:1:1:3 \
  -vec 1:1:1:1:1:4

npic-mask d130_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:1 \
  -vec 0:0:0:1:1:1 \
  -vec 0:0:1:1:1:1 \
  -vec 0:1:1:1:1:2 \
  -vec 1:1:1:1:1:3

npic-mask d210_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:1 \
  -vec 0:0:0:1:1:1 \
  -vec 0:0:1:1:1:1 \
  -vec 0:1:1:1:1:1 \
  -vec 1:1:1:1:1:2

npic-mask d242_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:1 \
  -vec 0:0:0:1:1:1 \
  -vec 0:0:1:1:1:1 \
  -vec 0:1:1:1:1:1 \
  -vec 1:1:1:1:1:1

npic-mask d-3-4-5-6-7_5l.nmask -create -5l -dist -wd -ghalf \
  -vec 0:0:0:0:1:3 \
  -vec 0:0:0:1:1:4 \
  -vec 0:0:1:1:1:5 \
  -vec 0:1:1:1:1:6 \
  -vec 1:1:1:1:1:7


npic-mask d12_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:2 \
  -vec 0:0:0:1:1:1:3 \
  -vec 0:0:1:1:1:1:4 \
  -vec 0:1:1:1:1:1:5 \
  -vec 1:1:1:1:1:1:6

npic-mask d72_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:1 \
  -vec 0:0:0:1:1:1:2 \
  -vec 0:0:1:1:1:1:3 \
  -vec 0:1:1:1:1:1:4 \
  -vec 1:1:1:1:1:1:5

npic-mask d232_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:1 \
  -vec 0:0:0:1:1:1:1 \
  -vec 0:0:1:1:1:1:2 \
  -vec 0:1:1:1:1:1:3 \
  -vec 1:1:1:1:1:1:4

npic-mask d472_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:1 \
  -vec 0:0:0:1:1:1:1 \
  -vec 0:0:1:1:1:1:1 \
  -vec 0:1:1:1:1:1:2 \
  -vec 1:1:1:1:1:1:3

npic-mask d664_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:1 \
  -vec 0:0:0:1:1:1:1 \
  -vec 0:0:1:1:1:1:1 \
  -vec 0:1:1:1:1:1:1 \
  -vec 1:1:1:1:1:1:2

npic-mask d728_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:1 \
  -vec 0:0:0:0:1:1:1 \
  -vec 0:0:0:1:1:1:1 \
  -vec 0:0:1:1:1:1:1 \
  -vec 0:1:1:1:1:1:1 \
  -vec 1:1:1:1:1:1:1

npic-mask d-3-4-5-6-7-8_6l.nmask -create -6l -dist -wd -ghalf \
  -vec 0:0:0:0:0:1:3 \
  -vec 0:0:0:0:1:1:4 \
  -vec 0:0:0:1:1:1:5 \
  -vec 0:0:1:1:1:1:6 \
  -vec 0:1:1:1:1:1:7 \
  -vec 1:1:1:1:1:1:8


for dim in 2 3 4 5 6 ; do
for type in sed ced fed ; do
    npic-mask d-${type}_${dim}l.nmask -create -${dim}l -dist -$type
done
done


echo "regen-d.sh complete"

exit 0

