/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * calc_algeb.h - 17/01/2003
 *
 * Simple algebraic operations
*/


#ifndef NPIC__CALC_ALGEB_H
#define NPIC__CALC_ALGEB_H


/* PUBLIC */
void NpicLinearSum (Npic_image *dest, Npic_image *src1,  double c1,
    double c2);
void NpicBilinearSum (Npic_image *dest, Npic_image *src1, Npic_image
    *src2,  double c1, double c2, double c3);
void NpicTrilinearSum (Npic_image *dest, Npic_image *src1, Npic_image
    *src2,  Npic_image *src3, double c1, double c2, double c3, double c4);
void NpicQuadraticSum (Npic_image *dest, Npic_image *src1, double c1,
    double c2, double c3);
void NpicBiQuadraticSum (Npic_image *dest, Npic_image *src1, Npic_image
    *src2,  double c1, double c2, double c3, double c4, double c5);

/* PRIVATE */


#endif /* NPIC__CALC_ALGEB_H */
