/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * calc_draw.h - 04/02/2007
 *
 * Draw in image
*/


#ifndef NPIC__CALC_DRAW_H
#define NPIC__CALC_DRAW_H


/* PUBLIC */

void NpicDrawRect_2c (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_c val1);
void NpicDrawRect_2l (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_l val1);
void NpicDrawRect_2d (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_d val1);
void NpicDrawRect_3c (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawRect_3l (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawRect_3d (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawRect_4c (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawRect_4l (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawRect_4d (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawRect_5c (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawRect_5l (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawRect_5d (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawRect_6c (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawRect_6l (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawRect_6d (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawRect_2q (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawRect_3q (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawRect_4q (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawRect_5q (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawRect_6q (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);

void NpicDrawEllipse_2c (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_c val1);
void NpicDrawEllipse_2l (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_l val1);
void NpicDrawEllipse_2d (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        Npic_d val1);
void NpicDrawEllipse_3c (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawEllipse_3l (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawEllipse_3d (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawEllipse_4c (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawEllipse_4l (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawEllipse_4d (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawEllipse_5c (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawEllipse_5l (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawEllipse_5d (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawEllipse_6c (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_c val1);
void NpicDrawEllipse_6l (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_l val1);
void NpicDrawEllipse_6d (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        Npic_d val1);
void NpicDrawEllipse_2q (Npic_image *np, 
        int yP, int xP, 
        int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawEllipse_3q (Npic_image *np, 
        int zP, int yP, int xP, 
        int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawEllipse_4q (Npic_image *np, 
        int tP, int zP, int yP, int xP, 
        int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawEllipse_5q (Npic_image *np, 
        int sP, int tP, int zP, int yP, int xP, 
        int sQ, int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);
void NpicDrawEllipse_6q (Npic_image *np, 
        int rP, int sP, int tP, int zP, int yP, int xP, 
        int rQ, int sQ, int tQ, int zQ, int yQ, int xQ, 
        int a1, int b1, int c1, int d1);


/* For backward compatibility; deprecated since 0.19 */
#define NpicDrawRect_2cl NpicDrawRect_2l
#define NpicDrawRect_3cl NpicDrawRect_3l
#define NpicDrawRect_4cl NpicDrawRect_4l
#define NpicDrawEllipse_2cl NpicDrawEllipse_2l
#define NpicDrawEllipse_3cl NpicDrawEllipse_3l
#define NpicDrawEllipse_4cl NpicDrawEllipse_4l


/* PRIVATE */


#endif /* NPIC__CALC_DRAW_H */
