/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * calc_values.h - 14/01/2003
 *
 * Operations on pixel values
*/


#ifndef NPIC__CALC_VALUES_H
#define NPIC__CALC_VALUES_H


/* PUBLIC */

void NpicFillVal_i (Npic_image *np, int val1);
void NpicFillVal_d (Npic_image *np, double val1);
void NpicFillVal_q (Npic_image *np, int a, int b, int c, int d);

void NpicChangeVal_i (Npic_image *np, int val1, int val2);
void NpicChangeVal_d (Npic_image *np, double val1, double val2);
void NpicChangeVal_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);
    
void NpicExchangeVal_i (Npic_image *np, int val1, int val2);
void NpicExchangeVal_d (Npic_image *np, double val1, double val2);
void NpicExchangeVal_q (Npic_image *np, int a1, int b1, int c1, int d1,
    int a2, int b2, int c2, int d2);

double NpicMaxValue (Npic_image *np1);
double NpicMinValue (Npic_image *np1);


/* PRIVATE */


#endif /* NPIC__CALC_VALUES_H */
