/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * dist_dt.h - 07/01/2011
 *
 * Front-end for Distance Transforms
*/

#ifndef NPIC__DIST_DT_H
#define NPIC__DIST_DT_H



/* PUBLIC */

double NpicDT (Npic_image *np, Npic_mask *mh);
double NpicDT_inf (Npic_image *np, Npic_mask *mh);
double NpicDT_rev (Npic_image *np, Npic_mask *mh);


/* PRIVATE */

typedef enum {
    NPIC_DIST_NONE,
    NPIC_DIST_WEIGHTED,
    NPIC_DIST_EUCLID_SQUARED,
    NPIC_DIST_EUCLID_CEIL,
    NPIC_DIST_EUCLID_FLOOR,
} Npic_dist_type;

int NpicDTCheckData (Npic_image *np, Npic_mask *mh, const char *funcname);
Npic_dist_type NpicDTFindDistType (Npic_mask *mh);


#endif /* NPIC__DIST_DT_H */
