/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * dist_sedt_hirata.h - 25/09/2008
 *
 * Squared Euclidean Distance Transforms.
*/


#ifndef NPIC__DIST_SEDT_HIRATA_H
#define NPIC__DIST_SEDT_HIRATA_H



/* PUBLIC */

double NpicSEDT_Hirata (Npic_image *np);
double NpicSEDT_Hirata_inf (Npic_image *np);
double NpicSEDT_Hirata_rev (Npic_image *np);


/* PRIVATE */

double Npic_Hirata_inter (int u, int gu, int v, int gv);
void Npic_Hirata_scan (Npic_l *Cv, int cmax);
void Npic_Hirata_scan_inf (Npic_l *Cv, int cmax);
void Npic_Hirata_scan_rev (Npic_l *Cv, int cmax);


#endif /* NPIC__DIST_SEDT_HIRATA_H */
