/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * dist_sedt_saito.h - 25/09/2008
 *
 * Squared Euclidean Distance Transforms.
*/


#ifndef NPIC__DIST_SEDT_SAITO_H
#define NPIC__DIST_SEDT_SAITO_H



/* PUBLIC */

double NpicSEDT_Saito (Npic_image *np);
double NpicSEDT_Saito_inf (Npic_image *np);
double NpicSEDT_Saito_rev (Npic_image *np);


/* PRIVATE */

Npic_l Npic_Saito_min (Npic_l *Cv, int pos, int cmax);
Npic_l Npic_Saito_min_inf (Npic_l *Cv, int pos, int cmax);
Npic_l Npic_Saito_max_rev (Npic_l *Cv, int pos, int cmax);


#endif /* NPIC__DIST_SEDT_SAITO_H */
