/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * files_byext.h - 22/11/2010
 *
 * Read or write files by extensions
*/


#ifndef NPIC__FILES_BYEXT_H
#define NPIC__FILES_BYEXT_H


/* PUBLIC */

int NpicWriteImage (Npic_image *np, const char *filename);
Npic_image *NpicReadImage (const char *filename);
int NpicInfoImage (const char *filename);

#define NPIC_KNOWN_IMAGE_EXT  ".npz .pan|vol|pnm|pbm|pgm|ppm[.gz|bz2|7z]"
#define NPIC_KNOWN_MASK_EXT   ".nmask[.gz|bz2|7z]"


/* PRIVATE */

#endif /* NPIC__FILES_BYEXT_H */
