/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * files_gz.h - 15/03/2007
 *
 * Read or write gzip compressed files
*/


#ifndef NPIC__FILES_GZ_H
#define NPIC__FILES_GZ_H


/* PUBLIC */



/* PRIVATE */

typedef struct {
    int res, pid;
    struct sigaction old_sa, new_sa;
    FILE *f2;
    const char *funcname;
    const char *filename;
} Npic_file_gz;


void NpicWriteGZ_Open (Npic_file_gz *fgz, const char *filename, 
    const char *funcname, int do_append, Npic_file_compress comp);
void NpicWriteGZ_Close (Npic_file_gz *fgz);

void NpicReadGZ_Open (Npic_file_gz *fgz, const char *filename, 
    const char *funcname, int append_pos, Npic_file_compress comp);
void NpicReadGZ_Close (Npic_file_gz *fgz);


#endif /* NPIC__FILES_GZ_H */
