/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * files_npz.h - 28/03/2003
 *
 * File format NPZ
*/


#ifndef NPIC__FILES_NPZ_H
#define NPIC__FILES_NPZ_H


/* PUBLIC */

int NpicWriteNPZ (Npic_image *np, const char *filename);
Npic_image *NpicReadNPZ (const char *filename);
int NpicInfoNPZ (const char *filename);


/* PRIVATE */

#define NPIC_TEST16  0x1234
#define NPIC_TEST32  0x12345678
#define NPIC_TESTDBL 1.2345678987654321e-279

#define NPIC_NPZ_GZIP 1

typedef struct {
    int   version,
          type,
          dim,
          comp,
          xmax,
          ymax,
          zmax,
          tmax,
          smax,
          rmax;
    Npic_props props;
} Npic_npz_info;

int NpicWriteNPZHeader (Npic_image *np, FILE *f);
int NpicWriteNPZDatas (Npic_image *np, FILE *f);
int NpicNPZReadInfo (FILE *f, Npic_npz_info *info);
int NpicReadNPZDatas (Npic_image *np, FILE *f);
Npic_image *NpicCreateImageForNPZ (Npic_npz_info *info);
int NpicNPZPrintInfo (const char *filename, Npic_npz_info *info);


#endif /* NPIC__FILES_NPZ_H */
