/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * files_vol.h - 12/03/2007
 *
 * VOL - volume format from David Coeurjolly and Alexis Guillaume
 *
 * see http://www.cb.uu.se/~tc18/code_data_set/Code/Libvol/
*/


#ifndef NPIC__FILES_VOL_H
#define NPIC__FILES_VOL_H


/* PUBLIC */

int NpicWriteVOL (Npic_image *np, const char *filename, Npic_file_compress comp);
Npic_image *NpicReadVOL (const char *filename, Npic_file_compress comp);
int NpicInfoVOL (const char *filename, Npic_file_compress comp);


/* PRIVATE */

typedef struct {
    char  magic[16];         /* The magic number. */
    Npic_props props;        /* Text properties */
    int   xmax, ymax, zmax;  /* Image size */
    int   npic_type;         /* The equivallent NPIC type */
    int   npic_dim;          /* The NPIC dimension */
    int   bswap;             /* Must byteswap on reading for endianness */
} Npic_vol_info;

int NpicVOLWriteFile (Npic_image *np, FILE *f1, const char *filename, 
        const char *funcname);
Npic_image *NpicVOLReadFile (FILE *f1, const char *filename, 
        const char *funcname);
int NPicVOLReadInfo (FILE *f1, Npic_vol_info *info);
int NpicVOLReadDatas (Npic_image *np, FILE *f1, Npic_vol_info *info);
int NpicVOLPrintInfo (const char *filename, Npic_vol_info *info);
const char *NpicVolEndianC ();
const char *NpicVolEndianS ();
const char *NpicVolEndianL ();


#endif /* NPIC__FILES_VOL_H */
