/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * image_creat.h - 20/11/2008
 *
 * Manage memory in struct Npic_image
*/


#ifndef NPIC__IMAGE_CREAT_H
#define NPIC__IMAGE_CREAT_H


/* PUBLIC */

Npic_image *NpicCreateImage_2c (int ymax, int xmax, 
                                       int ybor, int xbor);
Npic_image *NpicCreateImage_2l (int ymax, int xmax, 
                                       int ybor, int xbor);
Npic_image *NpicCreateImage_2d (int ymax, int xmax, 
                                       int ybor, int xbor);
Npic_image *NpicCreateImage_2q (int ymax, int xmax, 
                                       int ybor, int xbor);
Npic_image *NpicCreateImage_3c (int zmax, int ymax, int xmax, 
                                       int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_3l (int zmax, int ymax, int xmax, 
                                       int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_3d (int zmax, int ymax, int xmax, 
                                       int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_3q (int zmax, int ymax, int xmax, 
                                       int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_4c (int tmax, int zmax, int ymax, int xmax, 
                                       int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_4l (int tmax, int zmax, int ymax, int xmax, 
                                       int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_4d (int tmax, int zmax, int ymax, int xmax, 
                                       int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_4q (int tmax, int zmax, int ymax, int xmax, 
                                       int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_5c (int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_5l (int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_5d (int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_5q (int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_6c (int rmax, int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_6l (int rmax, int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_6d (int rmax, int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicCreateImage_6q (int rmax, int smax, int tmax, int zmax, int ymax, int xmax, 
                                       int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);

Npic_image *NpicCreateImageNS (int ntype, Npic_vec *size);
Npic_image *NpicCreateImageDPS (int dim, int pixeltype, Npic_vec *size);

Npic_image *NpicDupImageB (Npic_image *src, 
        int tbor, int zbor, int ybor, int xbor);
Npic_image *NpicDupImageB6 (Npic_image *src, 
        int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);

Npic_image *NpicDupImage (Npic_image *src);
void NpicDestroyImage (Npic_image *np);
void NpicSwapImage (Npic_image *np1, Npic_image *np2);
void *NpicCastImage (Npic_image *np);


/* PRIVATE */

Npic_image *NpicCreateImages (
    const char *funcname, int type, int pixsize, int dim, 
    int rmax, int smax, int tmax, int zmax, int ymax, int xmax, 
    int rbor, int sbor, int tbor, int zbor, int ybor, int xbor);


#endif /* NPIC__IMAGE_CREAT_H */
