/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/* DO NOT EDIT !!!  Generated by npic-templa from "image_ntype.ct" */

/*
 * image_ntype.c - 16/01/2009
 *
 * Translate image type to name and vice-versa
*/


#include <npic.h>


/*--------------------- P U B L I C - I N T E R F A C E ----------------------*/

/*
 * Describe the image type corresponding to dim and pixeltype.
 * dim is in 2..6 and pixeltype is one of NPIC_C, NPIC_L, NPIC_D, NPIC_Q.
 *
 * Return one of these constants:  NPIC_IMAGE_2C, .. NPIC_IMAGE_6Q,
 * else NPIC_NONE on error. Silent.
*/

int NpicImageNtype (int dim, int pixeltype)
{
    switch (dim)
    {
        case 2 : switch (pixeltype) {
                case NPIC_C : return NPIC_IMAGE_2C;
                case NPIC_L : return NPIC_IMAGE_2L;
                case NPIC_D : return NPIC_IMAGE_2D;
                case NPIC_Q : return NPIC_IMAGE_2Q;
            } break;
        case 3 : switch (pixeltype) {
                case NPIC_C : return NPIC_IMAGE_3C;
                case NPIC_L : return NPIC_IMAGE_3L;
                case NPIC_D : return NPIC_IMAGE_3D;
                case NPIC_Q : return NPIC_IMAGE_3Q;
            } break;
        case 4 : switch (pixeltype) {
                case NPIC_C : return NPIC_IMAGE_4C;
                case NPIC_L : return NPIC_IMAGE_4L;
                case NPIC_D : return NPIC_IMAGE_4D;
                case NPIC_Q : return NPIC_IMAGE_4Q;
            } break;
        case 5 : switch (pixeltype) {
                case NPIC_C : return NPIC_IMAGE_5C;
                case NPIC_L : return NPIC_IMAGE_5L;
                case NPIC_D : return NPIC_IMAGE_5D;
                case NPIC_Q : return NPIC_IMAGE_5Q;
            } break;
        case 6 : switch (pixeltype) {
                case NPIC_C : return NPIC_IMAGE_6C;
                case NPIC_L : return NPIC_IMAGE_6L;
                case NPIC_D : return NPIC_IMAGE_6D;
                case NPIC_Q : return NPIC_IMAGE_6Q;
            } break;
    }

    return NPIC_NONE;
}


/*
 * Describe the pixel type from the image ntype.
 *
 * Return one of these constants:  NPIC_C, NPIC_L, NPIC_D or NPIC_Q,
 * else NPIC_NONE on error. Silent.
*/

int NpicImagePixelType (int ntype)
{
    switch (ntype)
    {
        case NPIC_IMAGE_2C : return NPIC_C;
        case NPIC_IMAGE_3C : return NPIC_C;
        case NPIC_IMAGE_4C : return NPIC_C;
        case NPIC_IMAGE_5C : return NPIC_C;
        case NPIC_IMAGE_6C : return NPIC_C;
        case NPIC_IMAGE_2L : return NPIC_L;
        case NPIC_IMAGE_3L : return NPIC_L;
        case NPIC_IMAGE_4L : return NPIC_L;
        case NPIC_IMAGE_5L : return NPIC_L;
        case NPIC_IMAGE_6L : return NPIC_L;
        case NPIC_IMAGE_2D : return NPIC_D;
        case NPIC_IMAGE_3D : return NPIC_D;
        case NPIC_IMAGE_4D : return NPIC_D;
        case NPIC_IMAGE_5D : return NPIC_D;
        case NPIC_IMAGE_6D : return NPIC_D;
        case NPIC_IMAGE_2Q : return NPIC_Q;
        case NPIC_IMAGE_3Q : return NPIC_Q;
        case NPIC_IMAGE_4Q : return NPIC_Q;
        case NPIC_IMAGE_5Q : return NPIC_Q;
        case NPIC_IMAGE_6Q : return NPIC_Q;
    }

    return NPIC_NONE;
}


/*
 * Return the image type name from the image ntype. Silent.
*/

const char *NpicImageTypeName (int ntype)
{
    switch (ntype) {
        case NPIC_IMAGE_2C : return "NPIC_IMAGE_2C";
        case NPIC_IMAGE_2L : return "NPIC_IMAGE_2L";
        case NPIC_IMAGE_2D : return "NPIC_IMAGE_2D";
        case NPIC_IMAGE_2Q : return "NPIC_IMAGE_2Q";
        case NPIC_IMAGE_3C : return "NPIC_IMAGE_3C";
        case NPIC_IMAGE_3L : return "NPIC_IMAGE_3L";
        case NPIC_IMAGE_3D : return "NPIC_IMAGE_3D";
        case NPIC_IMAGE_3Q : return "NPIC_IMAGE_3Q";
        case NPIC_IMAGE_4C : return "NPIC_IMAGE_4C";
        case NPIC_IMAGE_4L : return "NPIC_IMAGE_4L";
        case NPIC_IMAGE_4D : return "NPIC_IMAGE_4D";
        case NPIC_IMAGE_4Q : return "NPIC_IMAGE_4Q";
        case NPIC_IMAGE_5C : return "NPIC_IMAGE_5C";
        case NPIC_IMAGE_5L : return "NPIC_IMAGE_5L";
        case NPIC_IMAGE_5D : return "NPIC_IMAGE_5D";
        case NPIC_IMAGE_5Q : return "NPIC_IMAGE_5Q";
        case NPIC_IMAGE_6C : return "NPIC_IMAGE_6C";
        case NPIC_IMAGE_6L : return "NPIC_IMAGE_6L";
        case NPIC_IMAGE_6D : return "NPIC_IMAGE_6D";
        case NPIC_IMAGE_6Q : return "NPIC_IMAGE_6Q";
        default :            return "ERROR";
    }
}


/*-------------------- P R I V A T E - F U N C T I O N S ---------------------*/

/*----------------------------------------------------------------------------*/

