/*
 * The Npic library
 *
 * Copyright (C) 2003 Edouard Thiel <Edouard.Thiel@lif.univ-mrs.fr>
 *
 * This library is free software under the terms of the 
 * GNU Lesser General Public License (LGPL) version 2.1.
*/

/*
 * misc.h - 31/01/2007
 *
 * Miscellaneous
*/


#ifndef NPIC__MISC_H
#define NPIC__MISC_H

/* Vector type; use of coords z, t, s, r is context dependent. */
typedef struct { int x, y, z, t, s, r; } Npic_vec;


/* PUBLIC */

double NpicGetTime ();
char *NpicStrndup (const char *s, size_t n);

#ifdef __APPLE__
/* Mac OS X don't have strndup even if _GNU_SOURCE is defined */
#define strndup NpicStrndup
#endif /* __APPLE__ */

/* PRIVATE */


#endif /* NPIC__MISC_H */

