#include <npic.h>

int main (int argc, char *argv[])
{
    Npic_file_hints h;
    int k;

    if (argc != 2) {
        fprintf (stderr, "Usage: %s filename\n", argv[0]);
        return 1;
    }

    k = NpicFileParseHints (argv[1], &h);
    if (k != NPIC_SUCCESS) NpicError ("##", k, "");

    printf ("real-name: \"%s\"\n", h.realname);
    printf ("extension: \"%s\"\n", h.extension);
    printf ("compression: %s\n",
        h.comp == NPIC_COMPRESS_NONE ? "none" :
        h.comp == NPIC_COMPRESS_GZ   ? "gz" :
        h.comp == NPIC_COMPRESS_BZ2  ? "bz2" :
        h.comp == NPIC_COMPRESS_7Z   ? "7z" :
        "error");
    printf ("options:\n");
    for (k = 0; h.hints[k] != NULL; k++)
        printf ("\"%s\"\n", h.hints[k]);
    printf ("\n");

    printf ("Hint \"binary\" is %s\n", 
        NpicFileHint (&h, "binary") >= 0 ? "set" : "not set");

    NpicFileFreeHints (&h);
    return 0;
}

